//+------------------------------------------------------------------+
//|                                               Simple MTF RSI.mq4 |
//|                               (c) Tomcat98, modified by Airquest |
//|                                             airquest@hotmail.com |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 3

#property indicator_color1 Yellow
#property indicator_color2 DodgerBlue
#property indicator_color3 Blue
#property indicator_level1     30.0
#property indicator_level2     50.0
#property indicator_level3     70.0

extern int TimeFrame1 =PERIOD_CURRENT;
extern bool ShowTF1   =True;
extern int TimeFrame2 =PERIOD_H4;
extern bool ShowTF2   =True;
extern int TimeFrame3 =PERIOD_D1;
extern bool ShowTF3   =True;
extern int RSIPeriod1 =14;
extern int RSIPeriod2 =14;
extern int RSIPeriod3 =14;
extern int Price1     =PRICE_CLOSE;
extern int Price2     =PRICE_CLOSE;
extern int Price3     =PRICE_CLOSE;
extern int Shift1     =0;
extern int Shift2     =0;
extern int Shift3     =0;
extern int CountBars1 =500;
extern int CountBars2 =500;
extern int CountBars3 =500;
extern int x_prd      =0;

//---- buffers
double Multi_Indic[];
double Multi_Indic1[];
double Multi_Indic2[];

string short_name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{

//---- name for DataWindow and indicator subwindow label 
    short_name = "Simple MTF RSI - "+TimeFrame1+" ("+RSIPeriod1+"), "+TimeFrame2+" ("+RSIPeriod2+"), "+TimeFrame3+" ("+RSIPeriod3+")";
    IndicatorShortName(short_name);
    IndicatorBuffers(3);
    SetIndexBuffer(0,Multi_Indic);   
    if (ShowTF1) SetIndexStyle(0,DRAW_LINE); else SetIndexStyle(0,DRAW_NONE);
    SetIndexShift(0,Shift1);
    SetIndexBuffer(1,Multi_Indic1);
    if (ShowTF2) SetIndexStyle(1,DRAW_LINE); else SetIndexStyle(1,DRAW_NONE);
    SetIndexShift(1,Shift2);
    SetIndexBuffer(2,Multi_Indic2);
    if (ShowTF3) SetIndexStyle(2,DRAW_LINE); else SetIndexStyle(2,DRAW_NONE);
    SetIndexShift(2,Shift3);
   
//----
   return (0);
}
int deinit()
{
   return (0);
}

//+------------------------------------------------------------------+
//| Skid                                                           |
//+------------------------------------------------------------------+

int start()
  {
   if (CountBars1>=Bars) CountBars1=Bars;
   SetIndexDrawBegin(0,Bars-CountBars1);
   SetIndexDrawBegin(1,Bars-CountBars2);
   SetIndexDrawBegin(2,Bars-CountBars3);

   int i, ii,iii, counted_bars=IndicatorCounted();

   double t_prd;

//----
   if(Bars<=x_prd) return(0);

//---- initial zero
   if(counted_bars<x_prd)
   {
      for(i=1;i<=x_prd;i++) Multi_Indic[CountBars1-i]=0.0;
      for(ii=1;ii<=x_prd;ii++) Multi_Indic1[CountBars1-ii]=0.0;
      for(iii=1;iii<=x_prd;iii++) Multi_Indic2[CountBars1-iii]=0.0;
   }

//----
   i=CountBars1-x_prd-1;
   ii=CountBars1-x_prd-1;
   iii=CountBars1-x_prd-1;

   t_prd=x_prd/2+1;

   while(i>=0)
   while(ii>=0)
   while(iii>=0)
     {
     Multi_Indic[i]=(iRSI(NULL,TimeFrame1,RSIPeriod1,Price1,i));
     Multi_Indic1[ii]=(iRSI(NULL,TimeFrame2,RSIPeriod2,Price2,ii));
     Multi_Indic2[iii]=(iRSI(NULL,TimeFrame3,RSIPeriod3,Price3,iii));
      i--;
      ii--;
      iii--;
     }
   return(0);
  }
  
//+------------------------------------------------------------------+